/*
* Copyright (c) 2009 Nokia Corporation and/or its subsidiary(-ies). 
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
package cenrep.tests;

import cenrep.CenrepFactory;
import cenrep.KeyRange;

import junit.textui.TestRunner;

/**
 * <!-- begin-user-doc -->
 * A test case for the model object '<em><b>Key Range</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are tested:
 * <ul>
 *   <li>{@link cenrep.IAccessable#getReadAccess() <em>Read Access</em>}</li>
 *   <li>{@link cenrep.IAccessable#getWriteAccess() <em>Write Access</em>}</li>
 *   <li>{@link cenrep.IAccessable#getGAccess() <em>GAccess</em>}</li>
 * </ul>
 * </p>
 * <p>
 * The following operations are tested:
 * <ul>
 *   <li>{@link cenrep.KeyRange#getGKeys() <em>Get GKeys</em>}</li>
 *   <li>{@link cenrep.RVG#canGenerate() <em>Can Generate</em>}</li>
 *   <li>{@link cenrep.RVG#setGConf(java.lang.String) <em>Set GConf</em>}</li>
 *   <li>{@link cenrep.RVG#setPriority(java.lang.String) <em>Set Priority</em>}</li>
 *   <li>{@link cenrep.RVG#getGPriority() <em>Get GPriority</em>}</li>
 *   <li>{@link cenrep.RVG#getFolder() <em>Get Folder</em>}</li>
 * </ul>
 * </p>
 * @generated
 */
public class KeyRangeTest extends AttributeAndDescriptionTest {

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static void main(String[] args) {
		TestRunner.run(KeyRangeTest.class);
	}

	/**
	 * Constructs a new Key Range test case with the given name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public KeyRangeTest(String name) {
		super(name);
	}

	/**
	 * Returns the fixture for this Key Range test case.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected KeyRange getFixture() {
		return (KeyRange)fixture;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see junit.framework.TestCase#setUp()
	 * @generated
	 */
	@Override
	protected void setUp() throws Exception {
		setFixture(CenrepFactory.eINSTANCE.createKeyRange());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see junit.framework.TestCase#tearDown()
	 * @generated
	 */
	@Override
	protected void tearDown() throws Exception {
		setFixture(null);
	}

	/**
	 * Tests the '{@link cenrep.IAccessable#getReadAccess() <em>Read Access</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.IAccessable#getReadAccess()
	 * @generated
	 */
	public void testGetReadAccess() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.IAccessable#setReadAccess(cenrep.Access) <em>Read Access</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.IAccessable#setReadAccess(cenrep.Access)
	 * @generated
	 */
	public void testSetReadAccess() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.IAccessable#getWriteAccess() <em>Write Access</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.IAccessable#getWriteAccess()
	 * @generated
	 */
	public void testGetWriteAccess() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.IAccessable#setWriteAccess(cenrep.Access) <em>Write Access</em>}' feature setter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.IAccessable#setWriteAccess(cenrep.Access)
	 * @generated
	 */
	public void testSetWriteAccess() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.IAccessable#getGAccess() <em>GAccess</em>}' feature getter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.IAccessable#getGAccess()
	 * @generated
	 */
	public void testGetGAccess() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.KeyRange#getGKeys() <em>Get GKeys</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.KeyRange#getGKeys()
	 * @generated
	 */
	public void testGetGKeys() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.RVG#canGenerate() <em>Can Generate</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.RVG#canGenerate()
	 * @generated
	 */
	public void testCanGenerate() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.RVG#setGConf(java.lang.String) <em>Set GConf</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.RVG#setGConf(java.lang.String)
	 * @generated
	 */
	public void testSetGConf__String() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.RVG#setPriority(java.lang.String) <em>Set Priority</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.RVG#setPriority(java.lang.String)
	 * @generated
	 */
	public void testSetPriority__String() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.RVG#getGPriority() <em>Get GPriority</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.RVG#getGPriority()
	 * @generated
	 */
	public void testGetGPriority() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

	/**
	 * Tests the '{@link cenrep.RVG#getFolder() <em>Get Folder</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see cenrep.RVG#getFolder()
	 * @generated
	 */
	public void testGetFolder() {
		// Ensure that you remove @generated or mark it @generated NOT
		fail();
	}

} //KeyRangeTest
